]> pd.if.org Git - zpackage/blobdiff - zpm-install
add sync columns for old metadata on update
[zpackage] / zpm-install
index 22192710afd1ccb589f959475f5ba27e30d84130..29d8c5d2fc270f0299bc5ecfcbbd46b280c405e1 100755 (executable)
@@ -1,5 +1,9 @@
 #!/bin/sh
 
+warn() {
+       echo $* 1>&2
+}
+
 die() {
        echo $* 1>&2
        exit 1
@@ -84,7 +88,7 @@ package=$(zpm quote "$name")
 pkgver=$(zpm quote "$version")
 pkgrel=$(zpm quote "$release")
 
-if [ -z "$rootdir" ]; then
+if [ -n "$rootdir" ]; then
        : rootdir=${rootdir%%/}
 fi
 
@@ -93,6 +97,9 @@ if [ -z "$localdb" ]; then
 fi
 
 if [ ! -f "$localdb" ]; then
+       if [ -n "$rootdir" ] && [ ! -d $rootdir ]; then
+               mkdir $rootdir || die "can't create $rootdir: $!"
+       fi
        for d in /var /var/lib /var/lib/zpm; do
                test -d $rootdir/$d || mkdir $rootdir/$d || die "can't create $rootdir/$d/: $!"
        done
@@ -156,6 +163,8 @@ for pkgstr in "$@"; do
        current=$(zpm list -s installed "$package")
        
        if [ $runscripts -gt 0 ]; then
+               # TODO run pre-upgrade script if needed
+               # zpm runscript -p pre-upgrade $current $pkgid
                zpm runscript -f $pkgfile -p pre-install $pkgid $current
                if [ $? -ne 0 ]; then
                        # TODO log
@@ -163,8 +172,16 @@ for pkgstr in "$@"; do
                fi
        fi
 
+       # remove the package if it exists.  can't be in an installed
+       # state, would have bailed above.  So, if it exists, can only
+       # be 'upgraded'.  This should be fast, because we won't run
+       # a garbage collect, so any possible duplicate files between
+       # an upgraded or removed files, if they're there, won't need
+       # to be merged.
+
        # only merge if localdb and pkgfile are different
        if [ "$pkgfile" != "$ZPMDB" ]; then
+               zpm rmpackage $pkgid
                zpm merge -f $pkgfile -s installing $pkgid
                if [ $? -ne 0 ]; then
                        # TODO log
@@ -203,7 +220,9 @@ for pkgstr in "$@"; do
        fi
 
        if [ $(id -u) -eq 0 ]; then
-               if [ -f $rootdir/sbin/ldconfig ]; then
+               if [ ! -d $rootdir/etc ]; then
+                       warn "no etc directory in $rootdir, skipping ldconfig"
+               elif [ -f $rootdir/sbin/ldconfig ]; then
                        $rootdir/sbin/ldconfig -r ${rootdir:-/}
                elif [ -f /sbin/ldconfig ]; then
                        /sbin/ldconfig -r ${rootdir:-/}